From 8eba4ba15ab85ac88f6a91676e60443842b3d954 Mon Sep 17 00:00:00 2001
From: Ivan Kluchnikov <kluchnikovi@gmail.com>
Date: Wed, 10 Jul 2013 20:21:07 +0400
Subject: [PATCH] Added vty command for setting Access control classes.

---
 openbsc/src/libbsc/bsc_vty.c |   62 ++++++++++++++++++++++++++++++++++++++++++
 1 files changed, 62 insertions(+), 0 deletions(-)

diff --git a/openbsc/src/libbsc/bsc_vty.c b/openbsc/src/libbsc/bsc_vty.c
index 98ad3e4..fad98a2 100644
--- a/openbsc/src/libbsc/bsc_vty.c
+++ b/openbsc/src/libbsc/bsc_vty.c
@@ -2059,6 +2059,67 @@ DEFUN(cfg_bts_rach_ec_allowed, cfg_bts_rach_ec_allowed_cmd,
 	return CMD_SUCCESS;
 }
 
+DEFUN(cfg_bts_rach_ac_classes, cfg_bts_rach_ac_classes_cmd,
+      "rach access control classes (0|1) (0|1) (0|1) (0|1) (0|1) (0|1) (0|1) (0|1) (0|1) (0|1) x (0|1) (0|1) (0|1) (0|1) (0|1)",
+      RACH_STR
+      "Access control classes\n"
+      "Access control classes\n"
+      "Access control classes\n"
+      "Access is NOT barred for ACC 0\n"
+      "Access is barred for ACC 0\n"
+      "Access is NOT barred for ACC 1\n"
+      "Access is barred for ACC 1\n"
+      "Access is NOT barred for ACC 2\n"
+      "Access is barred for ACC 2\n"
+      "Access is NOT barred for ACC 3\n"
+      "Access is barred for ACC 3\n"
+      "Access is NOT barred for ACC 4\n"
+      "Access is barred for ACC 4\n"
+      "Access is NOT barred for ACC 5\n"
+      "Access is barred for ACC 5\n"
+      "Access is NOT barred for ACC 6\n"
+      "Access is barred for ACC 6\n"
+      "Access is NOT barred for ACC 7\n"
+      "Access is barred for ACC 7\n"
+      "Access is NOT barred for ACC 8\n"
+      "Access is barred for ACC 8\n"
+      "Access is NOT barred for ACC 9\n"
+      "Access is barred for ACC 9\n"
+      "NO access control class 10, it is used for emergency calls supoort 0\n"
+      "Access is NOT barred for ACC 11 (for PLMN use)\n"
+      "Access is barred for ACC 11 (for PLMN use)\n"
+      "Access is NOT barred for ACC 12 (security services)\n"
+      "Access is barred for ACC 12 (security services)\n"
+      "Access is NOT barred for ACC 13 (public utilities (e.g. water/gas suppliers))\n"
+      "Access is barred for ACC 13 (public utilities (e.g. water/gas suppliers))\n"
+      "Access is NOT barred for ACC 14 (emergency services)\n"
+      "Access is barred for ACC 14 (emergency services)\n"
+      "Access is NOT barred for ACC 15 (PLMN staff)\n"
+      "Access is barred for ACC 15 (PLMN Staff)\n")
+{
+	struct gsm_bts *bts = vty->index;
+
+	bts->si_common.rach_control.t2 &= 0x4;
+	bts->si_common.rach_control.t3 = 0;
+
+	uint8_t i;
+	for (i = 0; i < argc; i++)
+	{
+		if (atoi(argv[i]) == 1) {
+			if (i < 8) {
+				bts->si_common.rach_control.t3 |= (0x1 << i);
+			}
+			else if (i < 10) {
+				bts->si_common.rach_control.t2 |= (0x1 << (i-8));
+			}
+			else {
+				bts->si_common.rach_control.t2 |= (0x1 << (i-7));
+			}
+		}
+	}
+	return CMD_SUCCESS;
+}
+
 DEFUN(cfg_bts_ms_max_power, cfg_bts_ms_max_power_cmd,
       "ms max power <0-40>",
       "MS Options\n"
@@ -3871,6 +3932,7 @@ int bsc_vty_init(const struct log_info *cat)
 	install_element(BTS_NODE, &cfg_bts_rach_nm_ldavg_cmd);
 	install_element(BTS_NODE, &cfg_bts_cell_barred_cmd);
 	install_element(BTS_NODE, &cfg_bts_rach_ec_allowed_cmd);
+	install_element(BTS_NODE, &cfg_bts_rach_ac_classes_cmd);
 	install_element(BTS_NODE, &cfg_bts_ms_max_power_cmd);
 	install_element(BTS_NODE, &cfg_bts_per_loc_upd_cmd);
 	install_element(BTS_NODE, &cfg_bts_cell_resel_hyst_cmd);
-- 
1.7.0.4

